]>
git.saurik.com Git - bison.git/blob - bootstrap
3 # Bootstrap this package from CVS.
5 # Copyright (C) 2003, 2004, 2005 Free Software Foundation, Inc.
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation; either version 2, or (at your option)
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
17 # You should have received a copy of the GNU General Public License
18 # along with this program; if not, write to the Free Software
19 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
22 # Written by Paul Eggert.
26 # Ensure file names are sorted consistently across platforms;
27 # e.g., m4/ulonglong_gl.m4 should follow m4/ulonglong.m4.
28 # Also, ensure diagnostics are in English, e.g., "wget --help" below.
38 echo "$0: usage: $0 [--gnulib-srcdir=DIR] [--cvs-user=USERNAME] [--skip-po]"
41 GNULIB_SRCDIR
=`expr "$option" : '--gnulib-srcdir=\(.*\)'`;;
43 CVS_USER
=`expr "$option" : '--cvs-user=\(.*\)'`;;
47 echo >&2 "$0: $option: unknown option"
52 echo "$0: Bootstrapping CVS $package..."
56 if [ "${2}" != - ]; then
57 CVS_PREFIX
=${CVS_PREFIX}${2}@
69 case ${GNULIB_SRCDIR--} in
71 if [ ! -d gnulib
]; then
72 echo "$0: getting gnulib files..."
74 case ${CVS_AUTH-anoncvs} in
76 CVS_PREFIX
='anoncvs@';;
78 CVS_PREFIX
="$CVS_USER${CVS_USER+@}";;
80 echo "$0: $CVS_AUTH: Unknown CVS access method" >&2
85 '') export CVS_RSH
=ssh;;
88 trap cleanup_gnulib
1 2 13 15
90 cvs
-z3 -q -d ${CVS_PREFIX}subversions.gnu.org
:/cvsroot
/gnulib co gnulib
||
98 <$GNULIB_SRCDIR/gnulib
-tool || exit
128 previous_gnulib_modules
=
129 while [ "$gnulib_modules" != "$previous_gnulib_modules" ]; do
130 previous_gnulib_modules
=$gnulib_modules
132 (echo "$gnulib_modules"
133 for gnulib_module in $gnulib_modules; do
134 $GNULIB_SRCDIR/gnulib-tool --extract-dependencies $gnulib_module
140 (for gnulib_module in $gnulib_modules; do
141 $GNULIB_SRCDIR/gnulib-tool --extract-filelist $gnulib_module
145 gnulib_dirs
=`echo "$gnulib_files" | sed 's,/[^/]*$,,' | sort -u`
146 mkdir -p $gnulib_dirs || exit
148 for gnulib_file
in $gnulib_files; do
152 m
4/onceonly_2_57.
m4) dest
=m
4/onceonly.
m4;;
153 # These will be overwritten by autopoint, which still uses
154 # old jm_.* macro names, so we have to keep both copies.
155 # m4/gettext.m4 isn't mentioned here, since it's patched below.
156 m
4/glibc21.
m4 | m
4/inttypes_h.
m4 | m
4/lib
-ld.
m4 | \
157 m
4/lib
-prefix.
m4 | m
4/po.
m4 | m
4/stdint_h.
m4 | m
4/uintmax_t.
m4 | \
159 dest
=`expr $gnulib_file : '\(.*\).m4'`_gl.
m4;;
163 echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file" &&
164 cp -p $GNULIB_SRCDIR/$gnulib_file $dest || exit
167 # This suppresses a bogus diagnostic
168 # "warning: macro `AM_LANGINFO_CODESET' not found in library".
169 echo "$0: patching m4/gettext.m4 so that AM_INTL_SUBDIR is empty ..."
171 /^AC_DEFUN(\[AM_INTL_SUBDIR],/,/^]/c\
172 AC_DEFUN([AM_INTL_SUBDIR], [])
173 ' m
4/gettext.
m4 >m
4/gettext_gl.
m4 || exit
180 case `wget --help` in
182 no_cache
='--no-cache';;
184 no_cache
='--cache=off';;
189 echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
191 rm -f dummy
`ls | sed -n '/\.gmo$/p; /\.po/p'` &&
192 wget
-nv -nd -r -l 1 -A .po
$no_cache \
193 http
://www.iro.umontreal.ca
/translation
/maint
/$package/ &&
194 ls *.po
| sed 's/\.po$//' >LINGUAS
199 echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
201 rm -f dummy
`ls | sed -n '/\.gmo$/p; /\.po$/p'` &&
202 wget
-nv -nd -r -l 1 -A .po
$no_cache \
203 http
://www.iro.umontreal.ca
/translation
/maint
/$package-runtime/ &&
205 # For translations that have not yet been upgraded to the new
206 # runtime-po domain, prime the pump by extracting the relevant
207 # strings from the obsolete translations.
208 # This code can be removed once the bison-runtime domain
209 # has been translated by each team.
210 for po
in ..
/po
/*.po
; do
211 test -f "$po" || continue
215 -e 'memory exhausted' \
220 /^msgid "syntax error; also memory exhausted"$/,/^$/d
223 if cmp -s $runpo- $runpo; then
228 test -s $runpo || rm -f $runpo
232 ls *.po
| sed 's/\.po$//' >LINGUAS
238 # Generate autoconf and automake snippets.
240 (echo '# This file is generated automatically by "bootstrap".' &&
241 echo 'AC_DEFUN([GNULIB_AUTOCONF_SNIPPET],[' &&
242 $GNULIB_SRCDIR/gnulib
-tool --extract-autoconf-snippet $gnulib_modules &&
244 ) >m
4/gnulib.
m4 || exit
246 (echo '# This file is generated automatically by "bootstrap".' &&
247 $GNULIB_SRCDIR/gnulib
-tool --extract-automake-snippet $gnulib_modules
248 ) >lib
/gnulib.mk
|| exit
251 # Reconfigure, getting other files.
253 echo "$0: autoreconf --verbose --install --force ..."
254 autoreconf
--verbose --install --force || exit
257 # We don't need intl, so remove it.
258 # Remove aclocal.m4 too, so that it gets rebuilt.
259 intl_files_to_remove
='
288 echo $0: rm -fr $intl_files_to_remove ...
289 rm -fr $intl_files_to_remove || exit
291 # Put bug-reporting address into po/Makevars.
292 echo "$0: sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars ..."
293 sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po
/Makevars.template
>po
/Makevars
295 # Likewise for runtime-po/Makevars, except also change a few other parameters.
297 s/^\(DOMAIN\) *=.*/\1 = bison-runtime/
298 s/^\(subdir\) *=.*/\1 = runtime-po/
299 s/^\(XGETTEXT_OPTIONS\) *=.*/\1 = --keyword=YY_/
300 ' <po
/Makevars
>runtime
-po/Makevars
302 # Copy identical files from po to runtime-po.
303 (cd po
&& cp -p Makefile.
in.
in *-quot *.header
*.
sed *.sin ..
/runtime
-po)
305 # if src/parse-gram.[ch] are out of date, rebuild them.
306 parse_gram_y
=`find src/parse-gram.y \
307 '(' -newer src/parse-gram.c -o -newer src/parse-gram.h ')' \
309 case $parse_gram_y in
311 echo "$0: warning: bootstrapping with old src/parse-gram.[ch] files."
313 echo "$0: touch -c src/parse-gram.[ch] ... "
314 touch -c src
/parse
-gram.
[ch
] || exit
316 echo "$0: ./configure --disable-nls ..."
317 .
/configure
--disable-nls || exit
319 echo "$0: (cd lib && make) ..."
320 (cd lib
&& make) || exit
322 echo "$0: (cd src && make) ..."
323 (cd src
&& make) || exit
325 echo "$0: rm -f src/parse-gram.c src/parse-gram.h ..."
326 rm -f src
/parse
-gram.c src
/parse
-gram.h
|| exit
328 echo "$0: (cd src && make parse-gram.c parse-gram.h) ..."
329 (cd src
&& make parse
-gram.c parse
-gram.h
) || exit
331 echo "$0: make distclean ..."
332 make distclean
|| exit;;
335 echo "$0: done. Now you can run './configure'."